#pragma once

#include "Matrix33.h"
#include "Matrix44.h"
#include "Function Templates.h"

static inline float DegToRad(float Angle);
static inline float RadToDeg(float Angle);
CMatrix44 IdentityMatrix44(void);
CMatrix44 TransposeMatrix44(const CMatrix44 &OtherMatrix);
CMatrix44 InvertMatrix44(const CMatrix44 &OtherMatrix);
CMatrix44 RotateRadMatrix44(char Axis, float Radian);
CMatrix44 RotateRadMatrix44(const CVector3 &Axis, float Radian);
CMatrix44 TranslateMatrix44(float X, float Y, float Z);
CMatrix44 ScaleMatrix44(float X, float Y, float Z, float W = 1.0);
CMatrix44 LookAtMatrix44(const CVector3 &CameraPos,const CVector3 &CameraUp,const CVector3 &Target);
CMatrix44 FrustumMatrix44(float Left,float Right,float Top,float Bottom,float Near,float Far);
CMatrix44 PerspectiveMatrix44(float fovY,float Aspect,float Near,float Far);
CMatrix44 OrthoMatrix44(float Left,float Right,float Top,float Bottom,float Near,float Far);
CMatrix44 OrthoNormalMatrix44(const CVector3 &xdir,const CVector3 &ydir,const CVector3 &zdir);