#pragma once
#include <cmath>
#include <cassert>

class CVector2 
	{
	public:
	float X, Y;

	public:
	CVector2(void): X(0),Y(0) {};
	CVector2(float NewX, float NewY): X(NewX), Y(NewY) {}
	CVector2(const CVector2 &Other): X(Other.X), Y(Other.Y) {}

	public:
	// Operadores internos
	float                    &operator [] (unsigned int Position);
	const float              &operator [] (unsigned int Position) const;
	CVector2                 &operator += (const CVector2 &Other);
	CVector2                 &operator -= (const CVector2 &Other);
	CVector2                 &operator *= (float Float);
	CVector2                 &operator /= (float Float);

	bool                     operator == (const CVector2 &V1);
	bool                     operator != (const CVector2 &V1);
	CVector2                 operator - (void);
	CVector2                 operator + (const CVector2 &V1);
	CVector2                 operator - (const CVector2 &V1);
	CVector2                 operator * (float Float);
	CVector2                 operator / (float Float);

	// externos
	friend bool              operator == (const CVector2 &V1, const CVector2 &V2);
	friend bool              operator != (const CVector2 &V1, const CVector2 &V2);
	friend CVector2          operator - (const CVector2 &V1);
	friend CVector2          operator + (const CVector2 &V1, const CVector2 &V2);
	friend CVector2          operator - (const CVector2 &V1, const CVector2 &V2);
	friend CVector2          operator * (const CVector2 &V1, float Float);
	friend CVector2          operator * (float Float, const CVector2 &V1);
	friend CVector2          operator / (const CVector2 &V1, float Float);

	// Funes
	void                     Set(float NewX, float NewY);
	float                    Length(void) const;
	float                    LengthSqr(void) const;
	bool                     IsZero(void) const;
	CVector2                 &Normalize(void);
	};
