#pragma once
#include <cmath>
#include <cassert>

#include "Vector2.h"
class CVector3 
	{
	public:
	float X, Y, Z;

	CVector3(void): X(0),Y(0),Z(0) {};
	CVector3(float NewX, float NewY, float NewZ): X(NewX), Y(NewY), Z(NewZ) {};
	CVector3(const CVector3 &V1): X(V1.X), Y(V1.Y), Z(V1.Z) {};
	explicit CVector3(const CVector2 &V1): X(V1.X), Y(V1.Y), Z(0.0F) {};

	// Operadores internos
	float                    &operator [] (unsigned int Index);
	const float              &operator [] (unsigned int Index) const;
	CVector3                 &operator =  (const CVector2 &OtherVector);
	CVector3                 &operator += (const CVector3 &OtherVector);
	CVector3                 &operator -= (const CVector3 &OtherVector);
	CVector3                 &operator *= (float Scalar);
	CVector3                 &operator /= (float Scalar);

	bool                     operator == (const CVector3 &OtherVector);
	bool                     operator != (const CVector3 &OtherVector);
	CVector3                 operator - (void);
	CVector3                 operator + (const CVector3 &OtherVector);
	CVector3                 operator - (const CVector3 &OtherVector);
	CVector3                 operator * (float Scalar);
	CVector3                 operator / (float Scalar);

	//externos
	friend bool              operator == (const CVector3 &V1, const CVector3 &V2);
	friend bool              operator != (const CVector3 &V1, const CVector3 &V2);
	friend CVector3          operator - (const CVector3 &V1);
	friend CVector3          operator + (const CVector3 &V1, const CVector3 &V2);
	friend CVector3          operator - (const CVector3 &V1, const CVector3 &V2);
	friend CVector3          operator * (const CVector3 &V1, float Scalar);
	friend CVector3          operator * (float Scalar, const CVector3 &V1);
	friend CVector3          operator / (const CVector3 &V1, float Scalar);
	void                     Set(float NewX, float NewY, float NewZ);
	float                    Length(void) const;
	float                    LengthSqr(void) const;
	bool                     IsZero(void) const;
	CVector3                 &Normalize(void);
	};
