#pragma once

#include "Vector2.h"
#include "Vector3.h"
#include "Vector4.h"

CVector2 Normalized(const CVector2 &V1);
CVector3 Normalized(const CVector3 &V1);
CVector4 Normalized(const CVector4 &V1);
float DotProduct(const CVector2 &V1, const CVector2 &V2);
float DotProduct(const CVector3 &V1, const CVector3 &V2);
float DotProduct(const CVector4 &V1, const CVector4 &V2);
void SwapVec(CVector2 &V1, CVector2 &V2);
void SwapVec(CVector3 &V1, CVector3 &V2);
void SwapVec(CVector4 &V1, CVector4 &V2);
CVector3 CrossProduct(const CVector3 &V1, const CVector3 &V2);
bool NearlyEquals(const CVector2 &V1, const CVector2 &V2, float Radius);
bool NearlyEquals(const CVector3 &V1, const CVector3 &V2, float Radius);
bool NearlyEquals(const CVector4 &V1, const CVector4 &V2, float Radius);
